/*
 * heat1d-i-glsc.c -- ŪǮ
 *
 *   ϡ, ʬȷ׻齬, Ʋ (1991) 11
 *   p237 Υץĥ
 *
 C     ** IMPLICIT FINITE DIFFERENCE METHOD **
 C     **         FOR HEAT EQUATION         **
 C     nfunc : ؿֹ5δؿѰդƤ
 C     theta : Υѥ᡼
 C     N : ʬο
 C     t : 
 C     tau : ֤ι
 C     Tmax : ξ
 C     h : ֤ι
 C     AL,AD,AU : 
 C     u : DIMENSION FOR UNKNOWN FUNCTION
 *
 *  Υץ
 *    http://www.math.meiji.ac.jp/%7Emk/program/
 *  ǽ
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define G_DOUBLE
#include <glsc.h>

/* ߼Ψ --- main()  pi = 4.0 * atan(1.0);  */

double pi;

void trilu(int, double *, double *, double *);
void trisol(int, double *, double *, double *, double *);
double f(double, int);
void print100(int, double, double *);
void axis(double, double, double, double);
void fsymbol(double, double, char *);
void print_parameters(double, double, double, double,
                      int, double, int,
                      double, double, double, double);
void save_picture(void);

int main()
{
    int N, nfunc, i, n, nMax;
    double a, b, theta, h, Tmax, tau, c1, c2, c3, c4, lambda, t;
    double *AL, *AD, *AU, *ff, *u;
    double xleft, ybottom, xright, ytop;
    /* դ񤭴ֳִ */
    double dt;
    /* ƥåפ˥դ񤭴뤫 */
    int skip;
    /* դä (0=No, 1=Yes) */
    int erase_always = 0;
    /* ͤɽ뤫? (0=No, 1=Yes) */
    int print_numerical_data = 0;
    /* */
    double win_width, win_height, w_margin, h_margin;

    /* ߼Ψ */
    pi = 4.0 * atan(1.0);
    /* ֤κüü */
    a = 0.0;
    b = 1.0;

    /*  */
    printf("ϤƲ : nfunc(1..5)=");
    scanf("%d", &nfunc);
    printf("ϤƲ : =");
    scanf("%lf", &theta);
    printf("ϤƲ : N=");
    scanf("%d", &N);
    printf("ϤƲ : =");
    scanf("%lf", &lambda);

    /* ٥ȥν */
    if ((AL = malloc(N * sizeof(double))) == NULL) {
        fprintf(stderr, "cannot allocate AL[]\n");
        exit(1);
    }
    if ((AD = malloc(N * sizeof(double))) == NULL) {
        fprintf(stderr, "cannot allocate AD[]\n");
        exit(1);
    }
    if ((AU = malloc(N * sizeof(double))) == NULL) {
        fprintf(stderr, "cannot allocate AU[]\n");
        exit(1);
    }
    if ((ff = malloc(N * sizeof(double))) == NULL) {
        fprintf(stderr, "cannot allocate ff[]\n");
        exit(1);
    }
    if ((u = malloc((N + 1) * sizeof(double))) == NULL) {
        fprintf(stderr, "cannot allocate u[]\n");
        exit(1);
    }
    /* */
    h = (b - a) / N;
    tau = lambda * h * h;
    printf(" ֤ι= %g ˤʤޤ\n", tau);

    /*  */
    printf("ϤƲ : ǽ Tmax=");
    scanf("%lf", &Tmax);
    printf("ϤƲ : ս񤭴ֳִ t=");
    scanf("%lf", &dt);
    skip = (int) rint(dt / tau);
    /* skip  0 ˤʤäƤʤå */
    if (skip == 0) {
	fprintf(stderr, "tΤǡt==%g ˤޤ\n", tau);
	skip = 1;
	dt = tau;
    }

    /* ν */
    c1 = - theta * lambda;
    c2 = 1.0 + 2.0 * theta * lambda;
    c3 = 1.0 - 2.0 * (1.0 - theta) * lambda;
    c4 = (1.0 - theta) * lambda;
    for (i = 1; i < N; i++) {
        AL[i] = c1;
        AD[i] = c2;
        AU[i] = c1;
    }

    /*  */
    for (i = 0; i <= N; i++)
        u[i] = f(a + i * h, nfunc);

    /* ϡt=0 */
    /* ϡʤǤϲ̤˿ͤɽ뤳ȡˤ FORTRAN  C 
       ʤۤʤΤǡľܤϽʤΤǡ
       print100 ȤؿˤޤȤ᤿ */
    t = 0.0;
    print100(N, t, u);

    /* ***************** եåν ***************** */
    /* եå̤ν -- ޤ̤ϰϤƤ */
    xleft = a - (b - a) / 10;
    xright = b + (b - a) / 10;
    ybottom = - 0.1;
    ytop = 1.1;
    /* ᥿ե̾ "HEAT",
     * ɥΥϡ
       win_width  + 2 * w_margin,  win_height + 2 * h_margin */
    win_width = 200.0; win_height = 200.0; w_margin = 10.0; h_margin = 10.0;
    g_init("HEAT", win_width  + 2 * w_margin, win_height + 2 * h_margin);
    /* ̤ȥ᥿եξ˵Ͽ */
    g_device(G_BOTH);
    /* ɸϤ: [-0.1,1.1][-0.1,1.1] Ȥΰɽ */
    g_def_scale(0,
               -0.1, 1.1, -0.1, 1.1,
                w_margin, h_margin, win_width, win_height);
    /* Ѱդ */
    g_def_line(0, G_BLACK, 0, G_LINE_SOLID);
    g_def_line(1, G_BLACK, 0, G_LINE_DOTS);
    /* ɽ뤿ʸ° */
    g_def_text(0, G_BLACK, 3);
    /* Τ򤹤 */
    g_sel_scale(0); g_sel_line(0); g_sel_text(0);

    /* ȥϥѥ᡼ɽ */
    print_parameters(xleft, ybottom, xright, ytop,
                     nfunc, theta, N,
                     lambda, tau, Tmax, t);

    /* ɸɽ */
    g_sel_line(1);
    g_move(-0.1, 0.0); g_plot(1.1, 0.0);
    g_move(0.0, -0.1); g_plot(0.0, 1.1);
    g_sel_line(0);

    /* t=0 ξ֤ɽ */
    g_move(0.0, u[0]);
    for (i = 1; i <= N; i++)
      g_plot(i * h, u[i]);

    /*  LU ʬ */
    trilu(N - 1, AL + 1, AD + 1, AU + 1);

    /* ֤׻ */
    nMax = (int) rint(Tmax / tau);
    for (n = 1; n <= nMax; n++) {
        /* ϢΩ1äƲ */
        for (i = 1; i < N; i++)
            ff[i] = c3 * u[i] + c4 * (u[i - 1] + u[i + 1]);
        trisol(N - 1, AL + 1, AD + 1, AU + 1, ff + 1);
        for (i = 1; i < N; i++)
            u[i] = ff[i];
        /*  */
        u[0] = 0.0;
        u[N] = 0.0;

        /*  */
        t = n * tau;

        if (n % skip == 0) {
            /* ͥǡɽ */
            if (print_numerical_data)
                print100(N, t, u);

            /* Υդ */
            if (erase_always) {
                /* ޤΤäѥ᡼ɽ */
                g_cls();
                print_parameters(xleft, ybottom, xright, ytop,
                                 nfunc, theta, N, lambda, tau, Tmax, t);
            }
            g_move(0.0, u[0]);
            for (i = 1; i <= N; i++)
              g_plot(i * h, u[i]);
        }
    }

    printf("ޥǥɥ򥯥åƲ\n");
    g_sleep(-1.0);
    g_term();

    return 0;
}

/**********************************************************/

/* гѹ LU ʬ (pivoting ʤ) */
void trilu(int n, double *al, double *ad, double *au)
{
  int i, nm1 = n - 1;
  /* ʾõ (forward elimination) */
  for (i = 0; i < nm1; i++) {
    al[i + 1] /= ad[i];
    ad[i + 1] -= au[i] * al[i + 1];
  }
}

/* LU ʬѤߤλгѹ򷸿˻Ļ */
void trisol(int n, double *al, double *ad, double *au, double *b)
{
  int i, nm1 = n - 1;
  /* ʾõ (forward elimination) */
  for (i = 0; i < nm1; i++) b[i + 1] -= b[i] * al[i + 1];
  /*  (backward substitution) */
  b[nm1] /= ad[nm1];
  for (i = n - 2; i >= 0; i--) b[i] = (b[i] - au[i] * b[i + 1]) / ad[i];
}

/**********************************************************/

/* ͿؿʣϿֹ nfunc 򤹤롣 */

double f(double x, int nfunc)
{
    /* f(x)=max(x,1-x) */
    if (nfunc == 1) {
        if (x <= 0.5)
            return x;
        else
            return 1.0 - x;
    }
    /* f(x)=1 */
    else if (nfunc == 2)
        return 1.0;
    else if (nfunc == 3)
        return sin(pi * x);
    /* f(x)= Ѥʷ򤷤(by M.Sakaue) */
    else if (nfunc == 4) {
        if (x <= 0.1)
            return 5 * x;
        else if (x <= 0.3)
            return -2 * x + 0.7;
        else if (x <= 0.5)
            return 4.5 * x - 1.25;
        else if (x <= 0.7)
            return -x + 1.5;
        else if (x <= 0.9)
            return x + 0.1;
        else
            return -10 * x + 10.0;
    }
    /* ϤоΤʷ򤷤(by M.Sakaue) */
    else if (nfunc == 5) {
        if (x <= 0.2)
            return -x + 0.8;
        else if (x <= 0.3)
            return 4 * x - 0.2;
        else if (x <= 0.4)
            return -4 * x + 2.2;
        else if (x <= 0.7)
            return -x + 1.0;
        else if (x <= 0.8)
            return 4 * x - 2.6;
        else
            return -x + 1.5;
    } else
        return 0;
}

/**********************************************************/

/*  u[] (u[0],u[1],...,u[n]) 5 Ĥɽ롣 */

void print100(int N, double t, double *u)
{
    int i;
    printf("T= %12.4e\n", t);
    for (i = 0; i < 5; i++)
        printf("  I     u(i)    ");
    printf("\n");
    for (i = 0; i <= N; i++) {
        printf("%3d%12.4e ", i, u[i]);
        if (i % 5 == 4)
            printf("\n");
    }
    printf("\n");
}

/**********************************************************/

/* ɥ˺ɸɽ */
void axis(double xleft, double ybottom, double xright, double ytop)
{
    g_sel_line(1);
    g_move(xleft, 0.0); g_plot(xright, 0.0);
    g_move(0.0, ybottom); g_plot(0.0, ytop);
    g_sel_line(0);
}

/* ѥ᡼򥦥ɥɽ */
void print_parameters(double xleft, double ybottom, double xright, double ytop,
                      int nfunc, double theta, int N,
                      double lambda, double tau, double Tmax, double t)
{
    char message[80];

    axis(xleft, ybottom, xright, ytop);

    g_text(30.0, 30.0, "heat equation, u(0)=u(1)=0");
    sprintf(message, "nfunc=%d, theta=%g, N=%d, lambda=%g, tau=%g, Tmax=%g",
            nfunc, theta, N, lambda, tau, Tmax);
    g_text(30.0, 60.0, message);
    if (t != 0.0) {
        sprintf(message, "t = %g", t);
        g_text(30.0, 90.0, message);
    }

}
