/*
 * heat2d-i.c --- 2Ǯ򱢲ˡǲ
 *                ˤʻˤ̤ͤο˴ޤʤˡ
 *                оӹǤ뤳ȤѤƲ
 *                (GLSC, matrix library )
 *
 *   ѥ뤹ˤ
 *     gcc -c symbandlu.c
 *     gcc -o heat2d-i heat2d-i.c symbandlu.o -lmatrix -lglscd -lX11 -lm
 *   뤤ϰľˤ
 *     ccmg heat2d-i.c symbandlu.c
 *
 *   FreeBSD Ǥϡ
 *      setenv LD_LIBRARY_PATH /usr/local/lib:/usr/X11R6/lib:/usr/lib
 *   뤤ϥѥ롦ץȤơ-lȤ 
 *      -L/usr/local/lib -L/usr/X11R6/lib
 *   ɬפˤʤ뤫
 */

#include <stdio.h>
#include <math.h>
#include <matrix.h>
#define G_DOUBLE
#include <glsc.h>
#include "symbandlu.h"

#define psi(i,j) (((j)-1)*mm+(i)-1)

int main()
{
    double a, b, c, d;
    int N_x, N_y, mm, NN, i, j, p, q, L, n, nMax;
    matrix Uk, A;
    double *B, *vector_U;
    int *iwork, skip;
    double h_x, h_y, lambda_x, lambda_y, lambda, lambda_limit, tau, Tmax, dt;
    double f(double, double), alpha(double, double);
    double theta, beta_0, beta_1, beta_2, beta_00, beta_10, beta_20;
    double x, y, t;

    /* ͤ [a,b][c,d] */
    a = 0.0; b = 1.0; c = 0.0; d = 1.0;

    /* ֤ʬ */
    printf("Nx, Ny: "); scanf("%d %d", &N_x, &N_y);

    mm = N_x - 1;
    NN = (N_x - 1) * (N_y - 1);
    /* ֤ι */
    h_x = (b - a) / N_x;
    h_y = (d - c) / N_y;

    /* 󡢥٥ȥ򵭲ѿΥ꡼ */
    if ((Uk = new_matrix(N_x + 1, N_y + 1)) == NULL) {
        fprintf(stderr, " U^k 򵭲ΰγݤ˼\n");
        exit(1);
    }
    if ((A = new_matrix(NN, mm + 1)) == NULL) {
        fprintf(stderr, " A 򵭲ΰγݤ˼\n");
        exit(1);
    }
    if ((B = (double *) malloc(sizeof(double) * NN)) == NULL) {
        fprintf(stderr, "B 򵭲ΰγݤ˼\n");
        exit(1);
    }
    if ((vector_U = (double *) malloc(sizeof(double) * NN)) == NULL) {
        fprintf(stderr, "vector_U 򵭲ΰγݤ˼\n");
        exit(1);
    }
    if ((iwork = (int *) malloc(sizeof(int) * NN)) == NULL) {
        fprintf(stderr, "iwork 򵭲ΰγݤ˼\n");
        exit(1);
    }

    /* ˡνŤߤη */
    printf(" (0ȡ1): "); scanf("%lf", &theta);

    if (theta == 1.0) {
        printf(": "); scanf("%lf", &tau);
    } else {
        printf("(%gͥΥ˴ؤӤξ): ",
               0.5 / (1 - theta) / (1 / (h_x * h_x) + 1 / (h_y * h_y)));
        scanf("%lf", &tau);
    }

    lambda_x = tau / (h_x * h_x);
    lambda_y = tau / (h_y * h_y);
    lambda = lambda_x + lambda_y;

    /* ͥΥ˴ؤˤξ */
    lambda_limit = 1.0 / (2.0 * (1.0 - theta));

    if (lambda > lambda_limit)
        printf(": =%g>1/2(1-) ȤʤäƤޤ\n", lambda);
    else
        printf("=%g\n", lambda);

    /* ͤ */
    for (i = 0; i <= N_x; i++) {
      x = a + i * h_x;
      for (j = 0; j <= N_y; j++)
        Uk[i][j] = f(x, c + j * h_y);
    }

    /* ϢΩ1˸뷸 */
    beta_0 = 1.0 + 2.0 * theta * lambda;
    beta_1 = -theta * lambda_x;
    beta_2 = -theta * lambda_y;

    beta_00 = 1.0 - 2.0 * (1.0 - theta) * lambda;
    beta_10 = (1.0 - theta) * lambda_x;
    beta_20 = (1.0 - theta) * lambda_y;

    /* κ */
    /* ޤ 0 ꥢ */
    for (p = 0; p < NN; p++) {
        for (q = 0; q <= mm; q++)
            A[p][q] = 0.0;
    }
    for (i = 1; i < N_x; i++)
        for (j = 1; j < N_y; j++) {
            L = psi(i, j);
	    /*
            if (j != 1) A[L][L - mm] = beta_2;
            if (i != 1) A[L][L -  1] = beta_1;
	    */
            A[L][0] = beta_0;     /* A[L][L] = beta_0; */
            if (i != N_x - 1)
               A[L][1] = beta_1;  /* A[L][L +  1] = beta_1; */
            if (j != N_y - 1)
               A[L][mm] = beta_2; /* A[L][L + mm] = beta_2; */
        }

    /* ϢΩ1ηɽ */
    if (NN < 20) {
      printf("ϢΩ1ι\n");
      for (p = 0; p < NN; p++) {
        for (q = 0; q <= mm; q++)
          printf(" %4.1f", A[p][q]);
        printf("\n");
      }
    }

    printf(": 1+2Ȧ=%4.1f, -Ȧx=%5.1f, -Ȧy=%5.1f\n",
           beta_0, beta_1, beta_2);

    printf("Tmax: "); scanf("%lf", &Tmax);
    printf("t: ");  scanf("%lf", &dt);
    skip = rint(dt / tau);
    if (skip == 0) {
       skip = 1;
    }
    dt = skip * tau;

    nMax = rint(Tmax / tau);

    /* եå饤֥ꥣ GLSC θƤӽФ */
    g_init("Meta", 250.0, 160.0);
    g_device(G_BOTH);
    g_def_scale(0,
                0.0, 1.0, 0.0, 1.0,
                30.0, 70.0, 100.0, 72.0);
    g_def_scale(4,
                -1.0, 1.0, -1.0, 1.0,
                30.0, 30.0, 100.0, 100.0);
    g_def_line(0, G_BLACK, 0, G_LINE_SOLID);
    g_sel_scale(0);

    g_cls();
    g_hidden2(1.0, 1.0, 0.4, -1.0, 1.0, 5.0, 25.0, 20.0, 20.0, 20.0,
              150.0, 100.0, Uk, N_x + 1, N_y + 1,
              1, G_SIDE_NONE, 2, 1);

    /*  LU ʬ */
    symbandlu(A, NN, mm+1);

    /* ֤˴ؤ롼 */
    for (n = 1; n <= nMax; n++) {

        /* ޤѤϢΩ1αդѰդ */
        /*  n ƥåפˤͤδͿ */
        for (i = 1; i < N_x; i++)
            for (j = 1; j < N_y; j++) {
                L = psi(i,j);
                B[L] = beta_00 * Uk[i][j]
                    + beta_10 * (Uk[i + 1][j] + Uk[i - 1][j])
                    + beta_20 * (Uk[i][j + 1] + Uk[i][j - 1]);
            }
        /*  n+1 ƥåפζγʻˤ () δͿ */
        for (j = 1; j < N_y; j++) {
            y = c + j * h_y;
            /* (1,j) ΤȤ */
            L = psi(1, j);
            B[L] -= beta_1 * alpha(a, y);
            /* (N_x-1,j) ΤȤ */
            L = psi(N_x - 1, j);
            B[L] -= beta_1 * alpha(b, y);
        }
        for (i = 1; i < N_x; i++) {
            x = a + i * h_x;
            /* (i,1) ΤȤ */
            L = psi(i, 1);
            B[L] -= beta_2 * alpha(x, c);
            /* (i,N_y-1) ΤȤ */
            L = psi(i, N_y - 1);
            B[L] -= beta_2 * alpha(x, d);
        }

        /* A vector_U = B  */
        symbandsolve(A, B, NN, mm+1);
        /* */
        for (i = 1; i < N_x; i++)
            for (j = 1; j < N_y; j++)
                Uk[i][j] = B[psi(i,j)];

        /* ադˤʻ (Ѥޤ) */
        for (i = 0; i <= N_x; i++) {
            x = a + i * h_x;
            Uk[i][0]   = alpha(x, c);
            Uk[i][N_y] = alpha(x, d);
        }
        /* ադˤʻ (Ѥϴޤʤ) */
        for (j = 1; j < N_y; j++) {
            y = c + j * h_y;
            Uk[0][j]   = alpha(a, y);
            Uk[N_x][j] = alpha(b, y);
        }

        /* ǡͤɽ */
        if (n % skip == 0) {
#ifdef  PRINT
            for (i = 0; i <= N_x; i++) {
                for (j = 0; j <= N_y; j++)
                    printf(" %5.1f", Uk[i][j]);
                printf("\n");
            }
#endif
            /* Ļ׿ޤ */
            g_cls();
            g_hidden2(1.0, 1.0, 0.4, -1.0, 1.0, 5.0, 25.0, 20.0, 20.0, 20.0,
                      150.0, 100.0, Uk, N_x + 1, N_y + 1,
                      1, G_SIDE_NONE, 2, 1);
        }
    }
    /* ޥǥåΤԤ */
    g_sleep(-1.0);
    /* ɥä */
    g_term();

    return 0;
}

/*  */
double f(double x, double y)
{
    /* ԥߥåɷδؿ */
    if (y > 0.5)
        y = 1 - y;
    if (x > 0.5)
        x = 1 - x;
    if (y < x)
        return 5 * y;
    else
        return 5 * x;
}

/*  */
double alpha(double x, double y)
{
    /* Ʊ Dirichlet  */
    return 0.0;
}
