/*
 * heat2n-adi.c --- 2ĹΰˤǮƳ (Neumann ) 
 *                  ADI ˡǲ򤯡
 *
 *   ѥ뤹ˤ
 *     gcc -c trid-lu.c
 *   Ȥtrid-lu.o äƤ
 *     gcc -o heat2n-adi heat2n-adi.c trid-lu.o -lmatrix -lglscd -lX11 -lm
 *   ޤ
 *     ccmg heat2n-adi.c trid-lu.c
 */

#include <stdio.h>
#include <math.h>
#include <matrix.h>
#define G_DOUBLE
#include <glsc.h>
#include "trid-lu.h"

double u0(double, double), beta(double, double);

int main()
{
    double a, b, c, d, c1, c2, c3, c4, c5, c6, c7, c8;
    int N_x, N_y, N, i, j, k, kmax, skip;
    double h_x, h_y, lambda_x, lambda_y, lambda, tau, Tmax, dt;
    double *alx, *adx, *aux, *aly, *auy, *ady, *ff, *gg;
    matrix U, newU;
    double t;

    /* Ĺΰ */
    a = 0.0; b = 1.0; c = 0.0; d = 1.0;

    /* ʬη */
    printf("Nx, Ny: "); scanf("%d %d", &N_x, &N_y);

    N = (N_x + 1) * (N_y + 1);
    h_x = (b - a) / N_x;
    h_y = (d - c) / N_y;

    /* ٥ȥ롢򵭲뤿ѿν */
    if ((alx = (double *) malloc(N_x * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate alx[]\n");
	exit(1);
    }
    if ((adx = (double *) malloc(N_x * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate adx[]\n");
	exit(1);
    }
    if ((aux = (double *) malloc(N_x * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate aux[]\n");
	exit(1);
    }
    if ((aly = (double *) malloc(N_y * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate aly[]\n");
	exit(1);
    }
    if ((ady = (double *) malloc(N_y * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate ady[]\n");
	exit(1);
    }
    if ((auy = (double *) malloc(N_y * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate auy[]\n");
	exit(1);

    }
    if ((ff = (double *) malloc(N_x * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate ff[]\n");
	exit(1);
    }
    if ((gg = (double *) malloc(N_y * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate gg[]\n");
	exit(1);
    }
    if ((newU = new_matrix(N_x + 1, N_y + 1)) == NULL) {
	fprintf(stderr, " newU 򵭲ΰγݤ˼\n");
	exit(1);
    }
    if ((U = new_matrix(N_x + 1, N_y + 1)) == NULL) {
	fprintf(stderr, " U 򵭲ΰγݤ˼\n");
	exit(1);
    }

    /* ֹη */
    printf("(۲ˡξΰΤξ=%g): ",
	   0.5 / (1 / (2 * h_x * h_x) + 1 / (2 * h_y * h_y)));
    scanf("%lf", &tau);

    /* ǽη */
    printf("Tmax: "); scanf("%lf", &Tmax);

    /* ѥ᡼η׻ */
    lambda_x = tau / (2 * h_x * h_x);
    lambda_y = tau / (2 * h_y * h_y);
    lambda = lambda_x + lambda_y;

    /* դ褹ֳִ֤η */
    printf("t: "); scanf("%lf", &dt);
    skip = dt / tau;

    /* դν (GLSC ν¾) */
    g_init("Meta", 250.0, 160.0);
    g_device(G_BOTH);
    g_def_scale(0, 0.0, 1.0, 0.0, 1.0, 30.0, 70.0, 100.0, 72.0);
    g_def_scale(4, -1.0, 1.0, -1.0, 1.0, 30.0, 30.0, 100.0, 100.0);
    g_def_line(0, G_BLACK, 0, G_LINE_SOLID);
    g_sel_scale(0);

    /*  */
    for (i = 0; i <= N_x; i++) {
	for (j = 0; j <= N_y; j++)
	    U[i][j] = u0(a + i * h_x, c + j * h_y);
    }

    /* Υդ */
    g_cls();
    g_hidden2(1.0, 1.0, 0.4, -1.0, 1.0, 5.0, 25.0, 20.0, 20.0, 20.0,
	      150.0, 100.0, U, N_x + 1, N_y + 1,
	      1, G_SIDE_NONE, 2, 1);

    /* η׻ (ΰ) */
    c1 = 1.0 + 2.0 * lambda_x;
    c2 = -lambda_x;
    c3 = 1.0 - 2.0 * lambda_y;
    c4 = lambda_y;
    for (i = 1; i < N_x; i++) {
	alx[i] = c2; adx[i] = c1; aux[i] = c2;
    }
    alx[0] = 0; adx[0] = c1; aux[0] = 2 * c2;
    alx[N_x] = 2 * c2; adx[N_x] = c1; aux[N_x] = 0;

    /* η׻ () */
    c5 = 1.0 + 2.0 * lambda_y;
    c6 = -lambda_y;
    c7 = 1.0 - 2.0 * lambda_x;
    c8 = lambda_x;
    for (j = 1; j < N_y; j++) {
	aly[j] = c6; ady[j] = c5; auy[j] = c6;
    }
    aly[0] = 0; ady[0] = c5; auy[0] = 2 * c6;
    aly[N_y] = 2 * c6; ady[N_y] = c5; auy[N_y] = 0;

    kmax = Tmax / tau + 0.5;
    printf("skip = %d\n", skip);

    /* LUʬ */
    trilu(N_y + 1, aly, ady, auy);
    trilu(N_x + 1, alx, adx, aux);

    /* ֤˴ؤ롼 */
    for (k = 1; k <= kmax; k++) {
        /*  kʤk1/2ʤޤǤϢΩ1 */
	for (j = 0; j <= N_y; j++) {
	    double y = c + j * h_y;
	    for (i = 0; i <= N_x; i++) {
	      double x = a + i * h_x;
	      if (j == 0)
		ff[i] = c3 * U[i][0]
		  + 2 * lambda_y * (U[i][1] + h_y * beta(x, c));
	      else if (j == N_y)
		ff[i] = c3 * U[i][N_y]
		  + 2 * lambda_y * (U[i][N_y - 1] + h_y * beta(x, d));
	      else
		ff[i] = c3 * U[i][j] + lambda_y * (U[i][j + 1] + U[i][j - 1]);
	    }
	    ff[0]   += 2.0 * lambda_x * h_x * beta(a, y);
	    ff[N_x] += 2.0 * lambda_x * h_x * beta(b, y);
	    /* ϢΩ1 */
	    trisol(N_x + 1, alx, adx, aux, ff);
	    /* 򵭲 */
	    for (i = 0; i <= N_x; i++)
		newU[i][j] = ff[i];
	}
	/* k+1/2ʤk+1ʤޤǤϢΩ1 */
	for (i = 0; i <= N_x; i++) {
	    double x = a + i * h_x;
	    for (j = 0; j <= N_y; j++) {
	      double y = c + j * h_y;
	      if (i == 0)
		gg[j] = c7 * newU[0][j]
		  + 2 * lambda_x * (newU[1][j] + h_x * beta(a, y));
	      else if (i == N_x)
		gg[j] = c7 * newU[N_x][j]
		  + 2 * lambda_x * (newU[N_x - 1][j] + h_x * beta(b, y));
	      else
		gg[j] = c7 * newU[i][j]
		  + lambda_x * (newU[i + 1][j] + newU[i - 1][j]);
	    }
	    gg[0]   += 2.0 * lambda_y * h_y * beta(x, c);
	    gg[N_y] += 2.0 * lambda_y * h_y * beta(x, d);
	    /* ϢΩ1 */
	    trisol(N_y + 1, aly, ady, auy, gg);
	    /* 򵭲 */
	    for (j = 0; j <= N_y; j++)
		U[i][j] = gg[j];
	}

	/* t Ȥ˥դ */
	if (k % skip == 0) {
	    g_cls();
	    g_hidden2(1.0, 1.0, 0.4, -1.0, 1.0, 5.0, 25.0, 20.0, 20.0, 20.0,
		      150.0, 100.0, U, N_x + 1, N_y + 1,
		      1, G_SIDE_NONE, 2, 1);
	}
	t = tau * k;
    }

    /* ޥǥåΤԤ */
    g_sleep(-1.0);
    /* ɥä */
    g_term();

    return 0;
}

double u0(double x, double y)
{
    /* ԥߥåɷδؿ */
    if (y > 0.5)
	y = 1 - y;
    if (x > 0.5)
	x = 1 - x;
    if (y < x)
	return 5 * y;
    else
	return 5 * x;
}

double beta(double x, double y)
{
    /*Ʊ Neumann  */
    return x * x - y * y;
    return 1.0;
    return 0.0;
}
