/*
 * heat2n-i.c --- 2Ǯ (Neumann ) 򱢲ˡǲ
 *   ѥ뤹ˤ
 *     gcc -c symbandlu.c
 *     gcc -o heat2n-i heat2n-i.c symbandlu.o -lmatrix -lglscd -lX11 -lm
 *   ľˤ
 *     ccmg heat2n-i.c symbandlu.c
 *
 *   FreeBSD Ǥϡ
 *      setenv LD_LIBRARY_PATH /usr/local/lib:/usr/X11R6/lib:/usr/lib
 *   뤤ϥѥ롦ץȤơ-lȤ 
 *      -L/usr/local/lib -L/usr/X11R6/lib
 *   ɬפˤʤ뤫
 *
 *   ΥץˤĤƤ 1998 ǯ´γäз˴դޤ
 */

#include <stdio.h>
#include <math.h>
#include <matrix.h>
#define G_DOUBLE
#include <glsc.h>
#include "symbandlu.h"

#define phi(i,j) (j)*m+(i)

int main()
{
    double a, b, c, d;
    int N_x, N_y, m, N, i, j, p, q, L, n, nMax;
    matrix Uk, A;
    double *B, *vector_U, cond;
    int *iwork, skip;
    double h_x, h_y, lambda_x, lambda_y, lambda, lambda_limit, tau, Tmax, dt;
    double f(double, double), Phi(double, double, double);
    double theta, gamma, alpha, beta, gamma_p, alpha_p, beta_p;
    double x, y, t, t_p;

    /* ͤ [a,b][c,d] */
    a = 0.0; b = 1.0; c = 0.0; d = 1.0;

    /* ֤ʬ */
    printf("Nx, Ny: "); scanf("%d %d", &N_x, &N_y);

    m = N_x + 1;
    N = (N_x + 1) * (N_y + 1);
    /* ֤ι */
    h_x = (b - a) / N_x;
    h_y = (d - c) / N_y;

    /* 󡢥٥ȥ򵭲ѿΥ꡼ */
    if ((Uk = new_matrix(N_x + 1, N_y + 1)) == NULL) {
        fprintf(stderr, " U^k 򵭲ΰγݤ˼\n");
        exit(1);
    }
    if ((A = new_matrix(N, m + 1)) == NULL) {
        fprintf(stderr, " A 򵭲ΰγݤ˼\n");
        exit(1);
    }
    if ((B = (double *) malloc(sizeof(double) * N)) == NULL) {
        fprintf(stderr, "B 򵭲ΰγݤ˼\n");
        exit(1);
    }
    if ((vector_U = (double *) malloc(sizeof(double) * N)) == NULL) {
        fprintf(stderr, "vector_U 򵭲ΰγݤ˼\n");
        exit(1);
    }
    if ((iwork = (int *) malloc(sizeof(int) * N)) == NULL) {
        fprintf(stderr, "iwork 򵭲ΰγݤ˼\n");
        exit(1);
    }

    /* ˡνŤߤη */
    printf(" (0ȡ1): "); scanf("%lf", &theta);

    if (theta == 1.0) {
        printf(": "); scanf("%lf", &tau);
    } else {
        printf("(%gͥΥ˴ؤӤξ): ",
               0.5 / (1 - theta) / (1 / (h_x * h_x) + 1 / (h_y * h_y)));
        scanf("%lf", &tau);
    }

    lambda_x = tau / (h_x * h_x);
    lambda_y = tau / (h_y * h_y);
    lambda = lambda_x + lambda_y;

    /* ͥΥ˴ؤˤξ */
    lambda_limit = 1.0 / (2.0 * (1.0 - theta));

    if (lambda > lambda_limit)
        printf(": =%g>1/2(1-) ȤʤäƤޤ\n", lambda);
    else
        printf("=%g\n", lambda);

    /* ͤ */
    for (i = 0; i <= N_x; i++) {
      x = a + i * h_x;
      for (j = 0; j <= N_y; j++)
        Uk[i][j] = f(x, c + j * h_y);
    }

    /* ϢΩ1˸뷸 
       U_{ij}^{n+1}
         +(U_{i+1,j}^{n+1}+U_{i-1,j}^{n+1})
         +(U_{i,j+1}^{n+1}+U_{i,j-1}^{n+1})
      ='U_{ij}^n
         +'(U_{i+1,j}^n+U_{i-1,j}^n)
         +'(U_{i,j+1}^n+U_{i,j-1}^n)
     Ƚ񤤤ȤΦ,,,',',' */
    gamma = 1.0 + 2.0 * theta * lambda;
    alpha = - theta * lambda_x;
    beta  = - theta * lambda_y;

    gamma_p = 1.0 - 2.0 * (1.0 - theta) * lambda;
    alpha_p = (1.0 - theta) * lambda_x;
    beta_p  = (1.0 - theta) * lambda_y;

    /* κ */
    /* ޤ 0 ꥢ */
    for (p = 0; p < N; p++) {
        for (q = 0; q <= m; q++)
            A[p][q] = 0.0;
    }
    for (i = 0; i <= N_x; i++)
        for (j = 0; j <= N_y; j++) {
            L = phi(i, j);
	    /*
            if (j != 0)   A[L][L - m] = beta;
            if (i != 0)   A[L][L - 1] = alpha;
	    */
                          A[L][0] = gamma; /* A[L][L    ] = gamma; */
            if (i != N_x) A[L][1] = alpha; /* A[L][L + 1] = alpha; */
            if (j != N_y) A[L][m] = beta;  /* A[L][L + m] = beta;  */
        }

    /* ޤϱ */
    for (j = 1; j < N_y; j++) {
        /* (0,j) */
        L = phi(0,j);
        A[L][0] /= 2.0; A[L][m] /= 2.0;
        /* A[L][L - m] /= 2.0; A[L][L] /= 2.0; A[L][L + m] /= 2.0; */
        /* (N_x,j) */
        L = phi(N_x,j);
        A[L][0] /= 2.0; A[L][m] /= 2.0;
        /* A[L][L - m] /= 2.0; A[L][L] /= 2.0; A[L][L + m] /= 2.0; */
    }

    /* ޤϾ */
    for (i = 1; i < N_x; i++) {
        /* (i,0) */
        L = phi(i,0);
        A[L][0] /= 2.0; A[L][1] /= 2.0;
        /* A[L][L - 1] /= 2.0; A[L][L] /= 2.0; A[L][L + 1] /= 2.0; */
        /* (i,N_y) */
        L = phi(i,N_y);
        A[L][0] /= 2.0; A[L][1] /= 2.0;
        /* A[L][L - 1] /= 2.0; A[L][L] /= 2.0; A[L][L + 1] /= 2.0; */
    }
    /* Ѥ */
    /*  */
    L = phi(0,0);
    A[L][0] /= 4.0; A[L][1] /= 2.0; A[L][m] /= 2.0;
    /* A[L][L] /= 4.0; A[L][L+1] /= 2.0; A[L][L+m] /= 2.0; */
    /*  */
    L = phi(0,N_y);
    A[L][0] /= 4.0; A[L][1] /= 2.0;
    /* A[L][L] /= 4.0; A[L][L+1] /= 2.0; A[L][L-m] /= 2.0; */
    /*  */
    L = phi(N_x,0);
    A[L][0] /= 4.0; A[L][m] /= 2.0;
    /* A[L][L] /= 4.0; A[L][L-1] /= 2.0; A[L][L+m] /= 2.0; */
    /*  */
    L = phi(N_x,N_y);
    A[L][0] /= 4.0;
    /* A[L][L] /= 4.0; A[L][L-1] /= 2.0; A[L][L-m] /= 2.0; */

    /* ϢΩ1ηɽ */
    if (N < 20) {
      printf("Ѥ˺äϢΩ1ι\n");
      for (p = 0; p < N; p++) {
        for (q = 0; q < N; q++)
          printf("%5.2f", A[p][q]);
        printf("\n");
      }
    }

    printf(": 1+2Ȧ=%5.2f, -Ȧx=%5.2f, -Ȧy=%5.2f\n",
           gamma, alpha, beta);

    printf("Tmax: "); scanf("%lf", &Tmax);
    printf("t: ");  scanf("%lf", &dt);
    skip = rint(dt / tau);
    if (skip == 0) skip = 1;

    nMax = rint(Tmax / tau);

    /* եå饤֥ꥣ GLSC θƤӽФ */
    g_init("Meta", 250.0, 160.0);
    g_device(G_BOTH);
    g_def_scale(0,
                0.0, 1.0, 0.0, 1.0,
                30.0, 70.0, 100.0, 72.0);
    g_def_scale(4,
                -1.0, 1.0, -1.0, 1.0,
                30.0, 30.0, 100.0, 100.0);
    g_def_line(0, G_BLACK, 0, G_LINE_SOLID);
    g_sel_scale(0);

    g_cls();
    g_hidden2(1.0, 1.0, 0.4, -1.0, 1.0, 5.0, 25.0, 20.0, 20.0, 20.0,
              150.0, 100.0, Uk, N_x + 1, N_y + 1,
              1, G_SIDE_NONE, 2, 1);

    /*  LU ʬ */
    symbandlu(A, N, m + 1);
    if (cond + 1 == cond) {
        /* 礭С׻򤢤 */
        printf("MATRIX IS SINGULAR TO WORKING PRECISION\n");
        return 0;
    }

    /* ֤˴ؤ롼 */
    for (n = 1; n <= nMax; n++) {
        t = n * tau; t_p = (n - 1) * tau;

        /* ޤѤϢΩ1αդѰդ */
        /* γʻ */
        for (i = 1; i < N_x; i++)
            for (j = 1; j < N_y; j++) {
                L = phi(i,j);
                B[L] = gamma_p * Uk[i][j]
                    + alpha_p * (Uk[i + 1][j] + Uk[i - 1][j])
                    + beta_p * (Uk[i][j + 1] + Uk[i][j - 1]);
            }
        /* ʲˤʻǤΩƤ롣
         * ۳ʻǤͤ϶濴ʬ
         * Ѥƾõ
         *   ġıդˤܹह̤ΤǡդˤĤƸǽ */
        /* ադˤʻ (Ѥϴޤʤ) */
        for (i = 1; i < N_x; i++) {
            x = a + i * h_x;
            /* (i, 0) */
            L = phi(i,0);
            B[L] = gamma_p * Uk[i][0]
                 + alpha_p * (Uk[i + 1][0] + Uk[i - 1][0])
                 + 2 * beta_p * Uk[i][1]
                 + 2 * h_y  * (beta * Phi(x, c, t) - beta_p * Phi(x, c, t_p));
            B[L] /= 2;
            /* (i, N_y) */
            L = phi(i,N_y);
            B[L] = gamma_p * Uk[i][N_y]
                 + alpha_p * (Uk[i + 1][N_y] + Uk[i - 1][N_y])
                 + 2 * beta_p * Uk[i][N_y - 1]
                 + 2 * h_y * (beta_p * Phi(x, d, t_p) - beta * Phi(x, d, t));
            B[L] /= 2;
        }
        /* ադˤʻ (Ѥϴޤʤ) */
        for (j = 1; j < N_y; j++) {
            y = c + j * h_y;
            /* (0, j) */
            L = phi(0,j);
            B[L] = gamma_p * Uk[0][j]
                 + 2 * alpha_p * Uk[1][j]
                 + beta_p * (Uk[0][j + 1] + Uk[0][j - 1])
                 + 2 * h_x * (alpha * Phi(a, y, t) - alpha_p * Phi(a, y, t_p));
            B[L] /= 2;
            /* (N_x, j) */
            L = phi(N_x,j);
            B[L] = gamma_p * Uk[N_x][j]
                 + 2 * alpha_p * Uk[N_x - 1][j]
                 + beta_p * (Uk[N_x][j + 1] + Uk[N_x][j - 1])
                 + 2 * h_x * (alpha_p * Phi(b, y, t_p) - alpha * Phi(b, y, t));
            B[L] /= 2;
        }
        /*  */
        L = phi(0,0);
        B[L] = gamma_p * Uk[0][0]
             + 2 * alpha_p * Uk[1][0] + 2 * beta_p * Uk[0][1]
             + 2 * h_x * (alpha * Phi(a,c,t) - alpha_p * Phi(a,c,t_p))
             + 2 * h_y * (beta * Phi(a,c,t) - beta_p * Phi(a,c,t_p));
            B[L] /= 4;
        /*  */
        L = phi(0,N_y);
        B[L] = gamma_p * Uk[0][N_y]
             + 2 * alpha_p * Uk[1][N_y] + 2 * beta_p * Uk[0][N_y - 1]
             + 2 * h_x * (alpha * Phi(a,d,t) - alpha_p * Phi(a,d,t_p))
             + 2 * h_y * (beta_p * Phi(a,d,t_p) - beta * Phi(a,d,t));
            B[L] /= 4;
        /*  */
        L = phi(N_x,0);
        B[L] = gamma_p * Uk[N_x][0]
             + 2 * alpha_p * Uk[N_x - 1][0] + 2 * beta_p * Uk[N_x][1]
             + 2 * h_x * (alpha_p * Phi(b,c,t_p) - alpha * Phi(b,c,t))
             + 2 * h_y * (beta * Phi(b,c,t) - beta_p * Phi(b,c,t_p));
	B[L] /= 4;
        /*  */
        L = phi(N_x,N_y);
        B[L] = gamma_p * Uk[N_x][N_y]
             + 2 * alpha_p * Uk[N_x - 1][N_y] + 2 * beta_p * Uk[N_x][N_y - 1]
             + 2 * h_x * (alpha_p * Phi(b,d,t_p) - alpha * Phi(b,d,t))
             + 2 * h_y * (beta_p * Phi(b,d,t_p) - beta * Phi(b,d,t));
	B[L] /= 4;

        /* A vector_U = B  */
        symbandsolve(A, B, N, m + 1);
        /* */
        for (i = 0; i <= N_x; i++)
            for (j = 0; j <= N_y; j++)
                Uk[i][j] = B[phi(i,j)];

        /* ǡͤɽ */
        if (n % skip == 0) {
#ifdef  PRINT
            for (i = 0; i <= N_x; i++) {
                for (j = 0; j <= N_y; j++)
                    printf(" %5.1f", Uk[i][j]);
                printf("\n");
            }
#endif

            /* Ļ׿ޤ */
            g_cls();
            g_hidden2(1.0, 1.0, 0.4, -1.0, 1.0, 5.0, 25.0, 20.0, 20.0, 20.0,
                      150.0, 100.0, Uk, N_x + 1, N_y + 1,
                      1, G_SIDE_NONE, 2, 1);
        }
    }
    /* ޥǥåΤԤ */
    g_sleep(-1.0);
    /* ɥä */
    g_term();

    return 0;
}

/*  */
double f(double x, double y)
{
    /* ԥߥåɷδؿ */
    if (y > 0.5)
        y = 1 - y;
    if (x > 0.5)
        x = 1 - x;
    if (y < x)
        return 5 * y;
    else
        return 5 * x;
}

/* Neumann  */
double Phi(double x, double y, double t)
{
    /* Ʊ Neumann  */
    return 0.0;
}
